﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="index.aspx.cs" Inherits="e_bind_gridview_with_jquery_ajax_index" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Bind GridView with jQuery AJAX | YogiHosting Demo</title>
    <link rel="icon" type="image/png" href="http://www.yogihosting.com/wp-content/themes/yogi-yogihosting/Images/favicon.ico" />
    <meta charset="utf-8" />
    <style>
        body {
            background: #111 no-repeat;
            background-image: -webkit-gradient(radial, 50% 0, 150, 50% 0, 300, from(#444), to(#111));
        }

        h1, h2 {
            text-align: center;
            color: #FFF;
        }

            h2 a {
                color: #0184e3;
                text-decoration: none;
            }

                h2 a:hover {
                    text-decoration: underline;
                }

        .container {
            width: 795px;
            margin: auto;
            color: #FFF;
            font-size: 25px;
        }

            .container h3 {
                font-size: 20px;
            }

        #content {
            position: relative;
            border: dashed 2px #CCC;
        }

            #content #loadingImg {
                display: none;
                position: absolute;
                margin: auto;
                top: 0;
                left: 0;
                right: 0;
                bottom: 0;
            }

            #content #gridView {
                background-color: purple;
            }

                #content #gridView tr th {
                    background-color: #CCC;
                }

            #content #submitButton {
                margin: 10px;
            }

        #pagingDiv {
            padding: 15px 0;
        }

            #pagingDiv .myDisableClass {
                background-color: #4CAF50;
            }

            #pagingDiv .myClass {
                background-color: #ebbebe;
            }

            #pagingDiv a, #pagingDiv span {
                display: inline-block;
                padding: 0px 9px;
                margin-right: 4px;
                border-radius: 3px;
                border: solid 1px #c0c0c0;
                background: #e9e9e9;
                box-shadow: inset 0px 1px 0px rgba(255,255,255, .8), 0px 1px 3px rgba(0,0,0, .1);
                font-size: .875em;
                font-weight: bold;
                text-decoration: none;
                color: #717171;
                text-shadow: 0px 1px 0px rgba(255,255,255, 1);
            }

                #pagingDiv a:hover {
                    cursor: pointer;
                    background: #fefefe;
                    background: -webkit-gradient(linear, 0% 0%, 0% 100%, from(#FEFEFE), to(#f0f0f0));
                    background: -moz-linear-gradient(0% 0% 270deg,#FEFEFE, #f0f0f0);
                }

                #pagingDiv a.active {
                    border: none;
                    background: #616161;
                    box-shadow: inset 0px 0px 8px rgba(0,0,0, .5), 0px 1px 0px rgba(255,255,255, .8);
                    color: #f0f0f0;
                    text-shadow: 0px 0px 3px rgba(0,0,0, .5);
                }

            #pagingDiv span {
                color: #f0f0f0;
                background: #616161;
            }


        #reset {
            padding: 5px 10px;
            background: #4CAF50;
            border: none;
            color: #FFF;
            cursor: pointer;
        }

            #reset:hover {
                color: #4CAF50;
                background: #FFF;
            }
    </style>
</head>
<body>
    <form id="form1" runat="server">
        <h1>Bind GridView with jQuery AJAX</h1>
        <h2><a href="http://www.yogihosting.com/bind-gridview-with-jquery-ajax/">Read the tutorial on YogiHosting »</a>
            <button id="reset">Reset »</button></h2>
        <div class="container">
            <div id="content">
                <asp:GridView ID="gridView" runat="server" AutoGenerateColumns="false">
                    <Columns>
                        <asp:BoundField DataField="RowNum" HeaderText="RowNum" />
                        <asp:BoundField DataField="ProductName" HeaderText="ProductName" />
                        <asp:BoundField DataField="QuantityPerUnit" HeaderText="QuantityPerUnit" />
                        <asp:BoundField DataField="UnitPrice" HeaderText="UnitPrice" />
                        <asp:BoundField DataField="UnitsInStock" HeaderText="UnitsInStock" />
                    </Columns>
                </asp:GridView>
                <div id="pagingDiv"></div>
                <asp:Button ID="submitButton" Text="Bind GridView" runat="server" />
                <img id="loadingImg" src="loading.gif" />
            </div>
        </div>
        <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.0/jquery.min.js"></script>
        <script type="text/javascript">
            $(document).ready(function () {
                $("#reset").click(function (e) {
                    location.reload();
                });

                $(document).ajaxStart(function () {
                    $("#loadingImg").show();
                });

                $(document).ajaxStop(function () {
                    $("#loadingImg").hide();
                });

                $("#submitButton").click(function (e) {
                    CallServerFunction(1);
                    $(this).hide();
                    return false;
                });

                function CallServerFunction(pageNo) {
                    $.ajax({
                        type: "POST",
                        url: "index.aspx/bind",
                        data: "{pageNo:" + pageNo + "}",
                        contentType: "application/json; charset=utf-8",
                        dataType: "json",
                        success: function (result, status, xhr) {
                            OnSuccess(result.d, pageNo);
                        },
                        error: function (req, status, error) {
                            alert(req + " " + status + " " + error);
                        }
                    });
                }

                function OnSuccess(message, pageNo) {
                    var xmlDoc = $.parseXML(message);
                    var xml = $(xmlDoc);
                    var product = xml.find("Table");
                    var row = $("[id*=gridView] tr:last-child").clone(true);
                    $("[id*=gridView] tr").not($("[id*=gridView] tr:first-child")).remove();

                    $.each(product, function () {
                        var customer = $(this);
                        $("td", row).eq(0).html($(this).find("RowNum").text());
                        $("td", row).eq(1).html($(this).find("ProductName").text());
                        $("td", row).eq(2).html($(this).find("QuantityPerUnit").text());
                        $("td", row).eq(3).html($(this).find("UnitPrice").text());
                        $("td", row).eq(4).html($(this).find("UnitsInStock").text());
                        $("[id*=gridView]").append(row);
                        row = $("[id*=gridView] tr:last-child").clone(true);
                    });

                    var result = Paging(pageNo, 10, xml.find("Table1 > Total").text(), "myClass", "myDisableClass");
                    $("#pagingDiv").html(result)

                    $("[id*=gridView]").css("display", "block");
                }

                $("#pagingDiv").on("click", "a", function () {
                    CallServerFunction($(this).attr("pn"));
                });

                function Paging(PageNumber, PageSize, TotalRecords, ClassName, DisableClassName) {
                    var ReturnValue = "";

                    var TotalPages = Math.ceil(TotalRecords / PageSize);
                    if (+PageNumber > 1) {
                        if (+PageNumber == 2)
                            ReturnValue = ReturnValue + "<a pn='" + (+PageNumber - 1) + "' class='" + ClassName + "'>Previous</a>&nbsp;&nbsp;&nbsp;";
                        else {
                            ReturnValue = ReturnValue + "<a pn='";
                            ReturnValue = ReturnValue + (+PageNumber - 1) + "' class='" + ClassName + "'>Previous</a>&nbsp;&nbsp;&nbsp;";
                        }
                    }
                    else
                        ReturnValue = ReturnValue + "<span class='" + DisableClassName + "'>Previous</span>&nbsp;&nbsp;&nbsp;";
                    if ((+PageNumber - 3) > 1)
                        ReturnValue = ReturnValue + "<a pn='1' class='" + ClassName + "'>1</a>&nbsp;.....&nbsp;|&nbsp;";
                    for (var i = +PageNumber - 3; i <= +PageNumber; i++)
                        if (i >= 1) {
                            if (+PageNumber != i) {
                                ReturnValue = ReturnValue + "<a pn='";
                                ReturnValue = ReturnValue + i + "' class='" + ClassName + "'>" + i + "</a>&nbsp;|&nbsp;";
                            }
                            else {
                                ReturnValue = ReturnValue + "<span style='font-weight:bold;'>" + i + "</span>&nbsp;|&nbsp;";
                            }
                        }
                    for (var i = +PageNumber + 1; i <= +PageNumber + 3; i++)
                        if (i <= TotalPages) {
                            if (+PageNumber != i) {
                                ReturnValue = ReturnValue + "<a pn='";
                                ReturnValue = ReturnValue + i + "' class='" + ClassName + "'>" + i + "</a>&nbsp;|&nbsp;";
                            }
                            else {
                                ReturnValue = ReturnValue + "<span style='font-weight:bold;'>" + i + "</span>&nbsp;|&nbsp;";
                            }
                        }
                    if ((+PageNumber + 3) < TotalPages) {
                        ReturnValue = ReturnValue + ".....&nbsp;<a pn='";
                        ReturnValue = ReturnValue + TotalPages + "' class='" + ClassName + "'>" + TotalPages + "</a>";
                    }
                    if (+PageNumber < TotalPages) {
                        ReturnValue = ReturnValue + "&nbsp;&nbsp;&nbsp;<a pn='";
                        ReturnValue = ReturnValue + (+PageNumber + 1) + "' class='" + ClassName + "'>Next</a>";
                    }
                    else
                        ReturnValue = ReturnValue + "&nbsp;&nbsp;&nbsp;<span class='" + DisableClassName + "'>Next</span>";

                    return (ReturnValue);
                }

            });
        </script>
    </form>
</body>
</html>
